AWSTemplateFormatVersion: 2010-09-09
Description: Launch Highly Available Active/Passive FortiGate-VM cluster in a new VPC
Metadata:
  'AWS::CloudFormation::Interface':
    ParameterGroups:
      - Label:
          default: VPC Configuration
        Parameters:
          - VPCCIDR
          - PublicSubnet
          - PublicSubnetRouterIP
          - PrivateSubnet
          - PrivateSubnetRouterIP
      - Label:
          default: FortiGate Instance Configuration
        Parameters:
          - AZForFGT
          - FGTInstanceType
          - FortiOSVersion
          - LicenseType
          - CIDRForFGTccess
          - KeyPair
      - Label:
          default: Contact
        Parameters:
          - EmailNotification
    ParameterLabels:
      FortiOSVersion:
        default: FotiOS Version
Parameters:
  VPCCIDR:
    Type: String
    Default: 10.0.0.0/16
    Description: Enter the VPC CIDR that you are using
  AZForFGT:
    Type: 'AWS::EC2::AvailabilityZone::Name'
    Description: Select the first AZ for FortiGateA
  PublicSubnet:
    Type: String
    Default: 10.0.1.0/24
    Description: Provide a network CIDR for the Public Subnet1
  PublicSubnetRouterIP:
    Type: String
    Default: 10.0.1.1
    Description: Provide the IP of the gateway for the public subnet1
  PrivateSubnet:
    Type: String
    Default: 10.0.2.0/24
    Description: Provide a network CIDR for the private subnet1
  PrivateSubnetRouterIP:
    Type: String
    Default: 10.0.2.1
    Description: Provide the IP of the gateway for the private subnet1
  FGTInstanceType:
    Type: String
    Default: c5.xlarge
    Description: Select the instance type for the FortiGates
    AllowedValues:
      - t3.medium
      - t3.xlarge
      - c5.large
      - c5.xlarge
      - c5.2xlarge
      - c5.4xlarge
      - c5.9xlarge
      - c5.18xlarge
      - c5n.large
      - c5n.xlarge
      - c5n.2xlarge
      - c5n.4xlarge
      - c5n.9xlarge
      - c5n.18xlarge
      - c6i.large
      - c6i.xlarge
      - c6i.2xlarge
      - c6i.4xlarge
      - c6i.8xlarge
      - c6i.16xlarge
      - c6i.24xlarge
      - c6in.large
      - c6in.xlarge
      - c6in.2xlarge
      - c6in.4xlarge
      - c6in.8xlarge
      - c6in.16xlarge
      - c7g.medium
      - c7g.large
      - c7g.xlarge
      - c7g.2xlarge
      - c7g.4xlarge
      - c7g.8xlarge
      - c7g.16xlarge
      - c7gn.large
      - c7gn.xlarge
      - c7gn.2xlarge
      - c7gn.4xlarge
      - c7gn.8xlarge
  FortiOSVersion:
    Type: String
    Default: 7.6.x
    Description: Select the verion of FortiOS to use (latest GA AMI will be used)
    AllowedValues:
      - 7.0.x
      - 7.2.x
      - 7.4.x
      - 7.6.x
  LicenseType:
    Type: String
    Description: Select the license type for the FortiGates
    AllowedValues:
      - BYOL
      - PAYG
  CIDRForFGTccess:
    Type: String
    Default: 0.0.0.0/0
    Description: Enter the CIDR from which FortiGate instances need to be accessed from
  KeyPair:
    Type: 'AWS::EC2::KeyPair::KeyName'
    Description: Select the keypair for the FortiGates
  EmailNotification:
    Type: String
    Default: admin@example.com
    Description: >-
      Provide an email address to receive notifications when the CloudWatch
      Failover Alarm is triggered
Mappings:
  FortiOSIntelAMISearchString:
    6.4.x:
      BYOL: FortiGate-VM64-AWS *(6.4.*)*|dlaioq277sglm5mw1y1dmeuqa
      PAYG: FortiGate-VM64-AWSONDEMAND *(6.4.*)*|2wqkpek696qhdeo7lbbjncqli
    7.0.x:
      BYOL: FortiGate-VM64-AWS *(7.0.*)*|dlaioq277sglm5mw1y1dmeuqa
      PAYG: FortiGate-VM64-AWSONDEMAND *(7.0.*)*|2wqkpek696qhdeo7lbbjncqli
    7.2.x:
      BYOL: FortiGate-VM64-AWS *(7.2.*)*|dlaioq277sglm5mw1y1dmeuqa
      PAYG: FortiGate-VM64-AWSONDEMAND *(7.2.*)*|2wqkpek696qhdeo7lbbjncqli
    7.4.x:
      BYOL: FortiGate-VM64-AWS *(7.4.*)*|dlaioq277sglm5mw1y1dmeuqa
      PAYG: FortiGate-VM64-AWSONDEMAND *(7.4.*)*|2wqkpek696qhdeo7lbbjncqli
    7.6.x:
      BYOL: FortiGate-VM64-AWS *(7.6.*)*|dlaioq277sglm5mw1y1dmeuqa
      PAYG: FortiGate-VM64-AWSONDEMAND *(7.6.*)*|2wqkpek696qhdeo7lbbjncqli
  FortiOSArmAMISearchString:
    6.4.x:
      BYOL: FortiGate-VMARM64-AWS *(6.4.*)*|33ndn84xbrajb9vmu5lxnfpjq
      PAYG: FortiGate-VMARM64-AWSONDEMAND *(6.4.*)*|8gc40z1w65qjt61p9ps88057n
    7.0.x:
      BYOL: FortiGate-VMARM64-AWS *(7.0.*)*|33ndn84xbrajb9vmu5lxnfpjq
      PAYG: FortiGate-VMARM64-AWSONDEMAND *(7.0.*)*|8gc40z1w65qjt61p9ps88057n
    7.2.x:
      BYOL: FortiGate-VMARM64-AWS *(7.2.*)*|33ndn84xbrajb9vmu5lxnfpjq
      PAYG: FortiGate-VMARM64-AWSONDEMAND *(7.2.*)*|8gc40z1w65qjt61p9ps88057n
    7.4.x:
      BYOL: FortiGate-VMARM64-AWS *(7.4.*)*|33ndn84xbrajb9vmu5lxnfpjq
      PAYG: FortiGate-VMARM64-AWSONDEMAND *(7.4.*)*|8gc40z1w65qjt61p9ps88057n
    7.6.x:
      BYOL: FortiGate-VMARM64-AWS *(7.6.*)*|33ndn84xbrajb9vmu5lxnfpjq
      PAYG: FortiGate-VMARM64-AWSONDEMAND *(7.6.*)*|8gc40z1w65qjt61p9ps88057n
Conditions:
  Graviton: !Or
    - !Equals
      - !Select
        - '0'
        - !Split
          - .
          - !Ref FGTInstanceType
      - c6g
    - !Equals
      - !Select
        - '0'
        - !Split
          - .
          - !Ref FGTInstanceType
      - c6gn
    - !Equals
      - !Select
        - '0'
        - !Split
          - .
          - !Ref FGTInstanceType
      - c7g
    - !Equals
      - !Select
        - '0'
        - !Split
          - .
          - !Ref FGTInstanceType
      - c7gn
Resources:
  VPCID:
    Properties:
      CidrBlock: !Ref VPCCIDR
      Tags:
        - Key: Name
          Value: !Join 
            - ''
            - - !Ref 'AWS::StackName'
              - VPCID
    Type: 'AWS::EC2::VPC'
  InstanceRole:
    Type: 'AWS::IAM::Role'
    Properties:
      AssumeRolePolicyDocument:
        Version: 2012-10-17
        Statement:
          - Effect: Allow
            Principal:
              Service:
                - ec2.amazonaws.com
            Action:
              - 'sts:AssumeRole'
      Path: /
      Policies:
        - PolicyName: ApplicationPolicy
          PolicyDocument:
            Version: 2012-10-17
            Statement:
              - Effect: Allow
                Action:
                  - 'ec2:Describe*'
                  - 'ec2:AssociateAddress'
                  - 'ec2:AssignPrivateIpAddresses'
                  - 'ec2:UnassignPrivateIpAddresses'
                  - 'ec2:ReplaceRoute'
                  - 's3:GetObject'
                Resource: '*'
  InstanceProfile:
    Type: 'AWS::IAM::InstanceProfile'
    Properties:
      Path: /
      Roles:
        - !Ref InstanceRole
  PrivateSubnetA:
    Properties:
      AvailabilityZone: !Ref AZForFGT
      CidrBlock: !Ref PrivateSubnet
      Tags:
        - Key: Name
          Value: !Join 
            - ''
            - - !Ref 'AWS::StackName'
              - PrivateSubnet
      VpcId: !Ref VPCID
    Type: 'AWS::EC2::Subnet'
  PublicSubnetA:
    Properties:
      AvailabilityZone: !Ref AZForFGT
      CidrBlock: !Ref PublicSubnet
      Tags:
        - Key: Name
          Value: !Join 
            - ''
            - - !Ref 'AWS::StackName'
              - PublicSubnet
      VpcId: !Ref VPCID
    Type: 'AWS::EC2::Subnet'
  AttachGateway:
    Properties:
      InternetGatewayId: !Ref InternetGateway
      VpcId: !Ref VPCID
    Type: 'AWS::EC2::VPCGatewayAttachment'
  InternetGateway:
    Properties:
      Tags:
        - Key: Name
          Value: !Join 
            - ''
            - - !Ref 'AWS::StackName'
              - IGW
    Type: 'AWS::EC2::InternetGateway'
  PublicDefaultRoute:
    DependsOn: AttachGateway
    Properties:
      DestinationCidrBlock: 0.0.0.0/0
      GatewayId: !Ref InternetGateway
      RouteTableId: !Ref RouteTable
    Type: 'AWS::EC2::Route'
  RouteTable:
    Properties:
      Tags:
        - Key: Name
          Value: !Join 
            - ''
            - - !Ref 'AWS::StackName'
              - PublicRoute
      VpcId: !Ref VPCID
    Type: 'AWS::EC2::RouteTable'
  FGTSecGrpBase:
    Type: 'AWS::EC2::SecurityGroup'
    Properties:
      VpcId: !Ref VPCID
      GroupDescription: FGTSecGrp
      SecurityGroupIngress:
        - Description: Allow remote access to FGT
          IpProtocol: '-1'
          FromPort: 0
          ToPort: 65535
          CidrIp: !Ref CIDRForFGTccess
        - Description: Allow local VPC access to FGT
          IpProtocol: '-1'
          FromPort: 0
          ToPort: 65535
          CidrIp: !Ref VPCCIDR
  FGTSecGrpFGTRule:
    Type: 'AWS::EC2::SecurityGroupIngress'
    Properties:
      GroupId: !Ref FGTSecGrpBase
      Description: Allow FGTs to access each other
      IpProtocol: '-1'
      FromPort: 0
      ToPort: 65535
      SourceSecurityGroupId: !Ref FGTSecGrpBase
  FGT:
    Type: 'AWS::EC2::Instance'
    Properties:
      ImageId: !GetAtt RunImageFunction.ami
      InstanceType: !Ref FGTInstanceType
      IamInstanceProfile: !Ref InstanceProfile
      KeyName: !Ref KeyPair
      NetworkInterfaces:
        - NetworkInterfaceId: !Ref FGTENI0
          DeviceIndex: '0'
        - NetworkInterfaceId: !Ref FGTENI1
          DeviceIndex: '1'
      Tags:
        - Key: Name
          Value: !Join 
            - ''
            - - !Ref 'AWS::StackName'
              - '-FGT'
      UserData: !Base64 
        'Fn::Join':
          - |+

          - - config system vdom-exception
            - edit 0
            - set object router.static
            - next
            - edit 0
            - set object system.interface
            - end
            - config system global
            - set hostname FGT
            - end
            - config system interface
            - edit port1
            - set alias public
            - set mode static
            - !Join 
              - ''
              - - 'set ip '
                - !GetAtt 
                  - FGTENI0
                  - PrimaryPrivateIpAddress
                - /
                - !Select 
                  - '1'
                  - !Split 
                    - /
                    - !Ref PublicSubnet
            - set allowaccess ping https ssh
            - set mtu-override enable
            - set mtu 9001
            - next
            - edit port2
            - set alias private
            - set mode static
            - !Join 
              - ''
              - - 'set ip '
                - !GetAtt 
                  - FGTENI1
                  - PrimaryPrivateIpAddress
                - /
                - !Select 
                  - '1'
                  - !Split 
                    - /
                    - !Ref PrivateSubnet
            - set allowaccess ping https ssh
            - set mtu-override enable
            - set mtu 9001
            - next
            - end
            - config router static
            - edit 1
            - set device port1
            - !Join 
              - ''
              - - 'set gateway '
                - !Ref PublicSubnetRouterIP
            - next
            - edit 2
            - !Join 
              - ''
              - - 'set dst '
                - !Ref VPCCIDR
            - set device port2
            - !Join 
              - ''
              - - 'set gateway '
                - !Ref PrivateSubnetRouterIP
            - next
            - end
            - config firewall policy
            - edit 1
            - set name outbound-all
            - set srcintf port2
            - set dstintf port1
            - set srcaddr all
            - set dstaddr all
            - set action accept
            - set schedule always
            - set service ALL
            - set logtraffic all
            - set nat enable
            - next
            - end
  FGTENI0:
    Type: 'AWS::EC2::NetworkInterface'
    Properties:
      Description: port1
      GroupSet:
        - !Ref FGTSecGrpBase
      SourceDestCheck: false
      SubnetId: !Ref PublicSubnetA
      Tags:
        - Key: Name
          Value: !Join 
            - ''
            - - !Ref 'AWS::StackName'
              - FGTENI0
        - Key: Interface
          Value: eth0
  FGTENI1:
    Type: 'AWS::EC2::NetworkInterface'
    Properties:
      Description: port2
      GroupSet:
        - !Ref FGTSecGrpBase
      SourceDestCheck: false
      SubnetId: !Ref PrivateSubnetA
      Tags:
        - Key: Name
          Value: !Join 
            - ''
            - - !Ref 'AWS::StackName'
              - FGTENI1
  ClusterEIP:
    Type: 'AWS::EC2::EIP'
    Properties:
      Domain: vpc
    DependsOn: FGT
  FGTMgmtEIP:
    Type: 'AWS::EC2::EIP'
    Properties:
      Domain: vpc
    DependsOn: FGT
  ClusterAEIPASSOCIATION:
    Type: 'AWS::EC2::EIPAssociation'
    Properties:
      AllocationId: !GetAtt 
        - ClusterEIP
        - AllocationId
      NetworkInterfaceId: !Ref FGTENI0
  PrivateRouteTable:
    Type: 'AWS::EC2::RouteTable'
    Properties:
      VpcId: !Ref VPCID
      Tags:
        - Key: Name
          Value: !Join 
            - ''
            - - !Ref 'AWS::StackName'
              - '-PrivateRouteTable'
  DefaultRoute:
    Type: 'AWS::EC2::Route'
    Properties:
      RouteTableId: !Ref PrivateRouteTable
      DestinationCidrBlock: 0.0.0.0/0
      NetworkInterfaceId: !Ref FGTENI1
  AZ1SubnetRouteTableAssociation:
    Type: 'AWS::EC2::SubnetRouteTableAssociation'
    Properties:
      SubnetId: !Ref PrivateSubnetA
      RouteTableId: !Ref PrivateRouteTable
  SubnetRouteTableAssociation1:
    Properties:
      RouteTableId: !Ref RouteTable
      SubnetId: !Ref PublicSubnetA
    Type: 'AWS::EC2::SubnetRouteTableAssociation'
  S3Endpoint:
    Type: 'AWS::EC2::VPCEndpoint'
    Properties:
      PolicyDocument:
        Version: 2012-10-17
        Statement:
          - Effect: Allow
            Principal: '*'
            Action:
              - 's3:*'
            Resource:
              - '*'
      RouteTableIds:
        - !Ref RouteTable
      ServiceName: !Join 
        - ''
        - - com.amazonaws.
          - !Ref 'AWS::Region'
          - .s3
      VpcId: !Ref VPCID
  CloudwatchAlarmFGT:
    Type: 'AWS::CloudWatch::Alarm'
    Properties:
      ActionsEnabled: true
      AlarmActions:
        - !Join 
          - ''
          - - 'arn:aws:automate:'
            - !Ref 'AWS::Region'
            - ':ec2:recover'
      AlarmDescription: Cloudwatch alarm to monitor instances status
      AlarmName: !Join 
        - ''
        - - !Ref 'AWS::StackName'
          - '-CWAlarmFGT'
      ComparisonOperator: GreaterThanThreshold
      Dimensions:
        - Name: InstanceId
          Value: !Ref FGT
      EvaluationPeriods: 3
      MetricName: StatusCheckFailed_System
      Namespace: AWS/EC2
      Period: 300
      Statistic: Minimum
      Threshold: 0
  LambdaRole:
    Type: AWS::IAM::Role
    Properties:
      AssumeRolePolicyDocument:
        Version: '2012-10-17'
        Statement:
          - Effect: Allow
            Principal:
              Service:
                - lambda.amazonaws.com
            Action:
              - sts:AssumeRole
      Path: /
      Policies:
        - PolicyName: S3AccessRole
          PolicyDocument:
            Version: '2012-10-17'
            Statement:
              - Effect: Allow
                Action:
                  - ec2:DescribeImages
                  - s3:PutObject
                Resource: '*'
              - Effect: Allow
                Action:
                  - logs:*
                Resource: '*'
  ImageFunction:
    Type: AWS::Lambda::Function
    Properties:
      Code:
        ZipFile: !Join
          - |+

          - - import boto3
            - import cfnresponse
            - import logging
            - import json
            - logger = logging.getLogger()
            - logger.setLevel(logging.INFO)
            - client = boto3.client('ec2')
            - ''
            - 'def handler(event, context):'
            - '    if event[''RequestType''] == ''Create'':'
            - '        logger.info(''<-- event received: {}''.format(json.dumps(event)))'
            - '        searchString = event[''ResourceProperties''][''SearchString'']'
            - '        productCode =  event[''ResourceProperties''][''ProductCode'']'
            - '    else:'
            - '        responseData = {''msg'':''200''}'
            - '        cfnresponse.send(event, context, cfnresponse.SUCCESS, responseData)'
            - '        return None'
            - ''
            - '    try:'
            - '        resp = client.describe_images('
            - '            Filters=[{''Name'': ''name'', ''Values'': [searchString]}, {''Name'': ''product-code'', ''Values'': [productCode]}],'
            - '            Owners=[''aws-marketplace'']'
            - '        )'
            - '    except Exception as error:'
            - '        logger.error(''<--!! Exception: {}''.format(error))'
            - '        responseData = {''msg'':''Exception: {}''.format(error)}'
            - '        cfnresponse.send(event, context, cfnresponse.FAILED, responseData)'
            - ''
            - '    if resp[''ResponseMetadata''][''HTTPStatusCode''] == 200 and resp[''Images''] != []:'
            - '        ami_dict = {}'
            - '        ami_list = []'
            - '        for entry in resp[''Images'']:'
            - '            key = entry[''CreationDate'']'
            - '            ami_dict[key] = entry[''ImageId'']'
            - '        ami_list = sorted(ami_dict, reverse = True)'
            - '        logger.info(''--> found latest AMI: {}, {}, {} {}''.format(ami_dict[ami_list[0]], ami_list[0], searchString, productCode))'
            - '        responseData = {''ami'': ami_dict[ami_list[0]]}'
            - '        cfnresponse.send(event, context, cfnresponse.SUCCESS, responseData)'
            - '    else:'
            - '        logger.error(''!!--> Unable to find AMI {} {} in describe_images response! {}''.format(searchString, productCode, resp))'
            - '        responseData = {''msg'':''Unable to find AMI {} {} in describe_images response! {}''.format(searchString, productCode,resp)}'
            - '        cfnresponse.send(event, context, cfnresponse.FAILED, responseData)'
            - ''
      Role: !GetAtt LambdaRole.Arn
      Timeout: 120
      Handler: index.handler
      Runtime: python3.9
      MemorySize: 128
  RunImageFunction:
    Type: Custom::ImageFunction
    Properties:
      ServiceToken: !GetAtt ImageFunction.Arn
      SearchString: !If
        - Graviton
        - !Select
          - '0'
          - !Split
            - '|'
            - !FindInMap
              - FortiOSArmAMISearchString
              - !Ref FortiOSVersion
              - !Ref LicenseType
        - !Select
          - '0'
          - !Split
            - '|'
            - !FindInMap
              - FortiOSIntelAMISearchString
              - !Ref FortiOSVersion
              - !Ref LicenseType
      ProductCode: !If
        - Graviton
        - !Select
          - '1'
          - !Split
            - '|'
            - !FindInMap
              - FortiOSArmAMISearchString
              - !Ref FortiOSVersion
              - !Ref LicenseType
        - !Select
          - '1'
          - !Split
            - '|'
            - !FindInMap
              - FortiOSIntelAMISearchString
              - !Ref FortiOSVersion
              - !Ref LicenseType
Outputs:
  FGTURL:
    Value: !Join 
      - ''
      - - 'https://'
        - !Ref FGTMgmtEIP
    Description: URL to access FortigateA
  FGTUsername:
    Value: admin
    Description: Username to access Fortigates
  FGTPassword:
    Value: !Ref FGT
    Description: Password to access FortigateA